Subject: Re: Regression in 32-bit ppc kernel

From: Benjamin Herrenschmidt <[email-masked]>
Date: Sun, 29 Apr 2012 08:41:10 +1000

On Sat, 2012-04-28 at 13:09 -0500, Larry Finger wrote:
> I have done a little more debugging. The problem is definitely coming
> from 
> drivers/tty/serial/pmac_zilog.c. I am getting ChanB interrupts while
> open, which 
> causes the following code segment to return IRQ_NONE:
> 
>         if (r3 & (CHBEXT | CHBTxIP | CHBRxIP)) {
>                 if (!ZS_IS_OPEN(uap_a)) {
>                         pmz_debug("ChanB interrupt while open !\n");
>                         goto skip_b;
>                 }
>                 write_zsreg(uap_b, R0, RES_H_IUS);
>                 zssync(uap_b);
>                 if (r3 & CHBEXT)
> 
> When this section is entered, r3 == 0x2 (CHBTxIP).
> 
> 
Ok. The debug code was meant to spell "while not open" btw :-)

I have some ideas what's going on. I think the irda stuff can trigger
interrupts during the open/close sequence before ZS_IS_OPEN is true.

I'll send a fix.

Cheers,
Ben.